/**
  * This file was generated from model [Model1] on [Thu Apr 06 16:48:05 MSD 2006].
  * Do not change content of this file.
  */

import java.util.*;

import com.evelopers.common.exception.*;
import com.evelopers.unimod.core.stateworks.*;
import com.evelopers.unimod.runtime.*;
import com.evelopers.unimod.runtime.context.*;


public class Model1EventProcessor extends AbstractEventProcessor {

	private ModelStructure modelStructure;

				private static final int AClient = 1;
			private static final int AServer = 2;
	
	private int decodeStateMachine(String sm) {
					
		if ("AClient".equals(sm)) {
			return AClient;
						} else 
				
		if ("AServer".equals(sm)) {
			return AServer;
			}

		return -1;
	}
		
			private AClientEventProcessor _AClient;
			private AServerEventProcessor _AServer;
		
	public Model1EventProcessor() {
		modelStructure = new Model1ModelStructure();

					_AClient = new AClientEventProcessor();
					_AServer = new AServerEventProcessor();
			}

    public ModelStructure getModelStructure() {
		return modelStructure;
	}	
	
    public void setControlledObjectsMap(ControlledObjectsMap controlledObjectsMap) {
        super.setControlledObjectsMap(controlledObjectsMap);
		
					_AClient.init(controlledObjectsMap);
					_AServer.init(controlledObjectsMap);
		    }

	protected StateMachineConfig process(
            Event event, StateMachineContext context,
            StateMachinePath path, StateMachineConfig config) throws SystemException {

		// get state machine from path
		int sm = decodeStateMachine(path.getStateMachine());
		
		try {
		switch (sm) {
					case AClient:
				return _AClient.process(event, context, path, config);
					case AServer:
				return _AServer.process(event, context, path, config);
					default:
				throw new EventProcessorException("Unknown state machine [" + path.getStateMachine() + "]");
		}
		} catch (Exception e) {
			if (e instanceof SystemException) {
				throw (SystemException)e;
			} else {
				throw new SystemException(e);
			}
		}
	}

    protected StateMachineConfig transiteToStableState(
            StateMachineContext context,
            StateMachinePath path, StateMachineConfig config) throws SystemException {

		// get state machine from path
		int sm = decodeStateMachine(path.getStateMachine());

		try {
		switch (sm) {
					case AClient:
				return _AClient.transiteToStableState(context, path, config);
					case AServer:
				return _AServer.transiteToStableState(context, path, config);
					default:
				throw new EventProcessorException("Unknown state machine [" + path.getStateMachine() + "]");
		}
		} catch (Exception e) {
			if (e instanceof SystemException) {
				throw (SystemException)e;
			} else {
				throw new SystemException(e);
			}
		}
	}	

	private class Model1ModelStructure implements ModelStructure {

	private Map configManagers = new HashMap();

	private Model1ModelStructure() {
					configManagers.put("AClient", new com.evelopers.unimod.runtime.config.DistinguishConfigManager());
					configManagers.put("AServer", new com.evelopers.unimod.runtime.config.DistinguishConfigManager());
			}

	public StateMachinePath getRootPath() throws EventProcessorException {
		return new StateMachinePath("AClient");				
	}

	public StateMachineConfigManager getConfigManager(String stateMachine) throws EventProcessorException {
		return (StateMachineConfigManager)configManagers.get(stateMachine);
	}

	public StateMachineConfig getTopConfig(String stateMachine) throws EventProcessorException {
		int sm = decodeStateMachine(stateMachine);
		
		switch (sm) {
					case AClient:
				return new StateMachineConfig("Top");
					case AServer:
				return new StateMachineConfig("Top");
					default:
				throw new EventProcessorException("Unknown state machine [" + stateMachine + "]");
		}
	}

	public boolean isFinal(String stateMachine, StateMachineConfig config) throws EventProcessorException {
		// get state machine from path
		int sm = decodeStateMachine(stateMachine);
		int state;
		
		switch (sm) {
					case AClient:
				state = _AClient.decodeState(config.getActiveState());
				switch (state) {
																																																																									case AClientEventProcessor.s2:
																																																																																																			    return true;
									default:
						return false;
				}
					case AServer:
				state = _AServer.decodeState(config.getActiveState());
				switch (state) {
																																														case AServerEventProcessor.s2:
																																																						    return true;
									default:
						return false;
				}
					default:
				throw new EventProcessorException("Unknown state machine [" + stateMachine + "]");
		}
	}			
}	
			







private class AClientEventProcessor {

		// states
	    private static final int Top = 1;
	    private static final int s1 = 2;
	    private static final int _4___ = 3;
	    private static final int _5___ = 4;
	    private static final int _3__ = 5;
	    private static final int _11___ = 6;
	    private static final int s2 = 7;
	    private static final int _13___ = 8;
	    private static final int _12____2 = 9;
	    private static final int _2___pin_ = 10;
	    private static final int _8___ = 11;
	    private static final int _10___ = 12;
	    private static final int _9___ = 13;
	    private static final int _1___ = 14;
	    private static final int _7____1 = 15;
	    private static final int _6____ = 16;
	
	private int decodeState(String state) {
					
		if ("Top".equals(state)) {
			return Top;
						} else 
				
		if ("s1".equals(state)) {
			return s1;
						} else 
				
		if ("4.  ".equals(state)) {
			return _4___;
						} else 
				
		if ("5.  ".equals(state)) {
			return _5___;
						} else 
				
		if ("3. ".equals(state)) {
			return _3__;
						} else 
				
		if ("11.  ".equals(state)) {
			return _11___;
						} else 
				
		if ("s2".equals(state)) {
			return s2;
						} else 
				
		if ("13.  ".equals(state)) {
			return _13___;
						} else 
				
		if ("12.   2".equals(state)) {
			return _12____2;
						} else 
				
		if ("2.  pin ".equals(state)) {
			return _2___pin_;
						} else 
				
		if ("8.  ".equals(state)) {
			return _8___;
						} else 
				
		if ("10.  ".equals(state)) {
			return _10___;
						} else 
				
		if ("9.  ".equals(state)) {
			return _9___;
						} else 
				
		if ("1.  ".equals(state)) {
			return _1___;
						} else 
				
		if ("7.   1".equals(state)) {
			return _7____1;
						} else 
				
		if ("6.   ".equals(state)) {
			return _6____;
			}
		
		return -1;
	}
	
		// events
	    private static final int e2 = 1;
	    private static final int e11 = 2;
	    private static final int e15 = 3;
	    private static final int e9 = 4;
	    private static final int e14 = 5;
	    private static final int e10 = 6;
	    private static final int e3 = 7;
	    private static final int e8 = 8;
	    private static final int e4 = 9;
	    private static final int e13 = 10;
	    private static final int e0 = 11;
	    private static final int e7 = 12;
	    private static final int e12 = 13;
	    private static final int e6 = 14;
	
	private int decodeEvent(String event) {
					
		if ("e2".equals(event)) {
			return e2;
						} else 
				
		if ("e11".equals(event)) {
			return e11;
						} else 
				
		if ("e15".equals(event)) {
			return e15;
						} else 
				
		if ("e9".equals(event)) {
			return e9;
						} else 
				
		if ("e14".equals(event)) {
			return e14;
						} else 
				
		if ("e10".equals(event)) {
			return e10;
						} else 
				
		if ("e3".equals(event)) {
			return e3;
						} else 
				
		if ("e8".equals(event)) {
			return e8;
						} else 
				
		if ("e4".equals(event)) {
			return e4;
						} else 
				
		if ("e13".equals(event)) {
			return e13;
						} else 
				
		if ("e0".equals(event)) {
			return e0;
						} else 
				
		if ("e7".equals(event)) {
			return e7;
						} else 
				
		if ("e12".equals(event)) {
			return e12;
						} else 
				
		if ("e6".equals(event)) {
			return e6;
				}
	
		return -1;
	}
		
							private client.FormPainter o1;
								private client.ServerQuery o2;
				
	private void init(ControlledObjectsMap controlledObjectsMap) {
									o1 = (client.FormPainter)controlledObjectsMap.getControlledObject("o1");
												o2 = (client.ServerQuery)controlledObjectsMap.getControlledObject("o2");
						}
		
	private StateMachineConfig process(Event event, StateMachineContext context, StateMachinePath path, StateMachineConfig config) throws Exception {
		config = lookForTransition(event, context, path, config);
		
		config = transiteToStableState(context, path, config);
		
		// execute included state machines
		executeSubmachines(event, context, path, config);
		
		return config;
	}
	
	private void executeSubmachines(Event event, StateMachineContext context, StateMachinePath path, StateMachineConfig config) throws Exception {
		int state = decodeState(config.getActiveState());
		
		while (true) {
		switch (state) {
																			case s1: 
					
											return;
																					case _4___: 
					
											return;
																					case _5___: 
																					// 5.   includes AServer
	
	fireBeforeSubmachineExecution(context, event, path, "5.  ", "AServer");
	
	Model1EventProcessor.this.process(event, context, new StateMachinePath(path,
		"5.  ", "AServer"));

    fireAfterSubmachineExecution(context, event, path, "5.  ", "AServer");
												
											return;
																					case _3__: 
																					// 3.  includes AServer
	
	fireBeforeSubmachineExecution(context, event, path, "3. ", "AServer");
	
	Model1EventProcessor.this.process(event, context, new StateMachinePath(path,
		"3. ", "AServer"));

    fireAfterSubmachineExecution(context, event, path, "3. ", "AServer");
												
											return;
																					case _11___: 
					
											return;
																					case s2: 
					
											return;
																					case _13___: 
					
											return;
																					case _12____2: 
					
											return;
																					case _2___pin_: 
					
											return;
																					case _8___: 
					
											return;
																					case _10___: 
					
											return;
																					case _9___: 
																					// 9.   includes AServer
	
	fireBeforeSubmachineExecution(context, event, path, "9.  ", "AServer");
	
	Model1EventProcessor.this.process(event, context, new StateMachinePath(path,
		"9.  ", "AServer"));

    fireAfterSubmachineExecution(context, event, path, "9.  ", "AServer");
												
											return;
																					case _1___: 
					
											return;
																					case _7____1: 
					
											return;
																					case _6____: 
					
											return;
																default:
					throw new EventProcessorException("State with name [" + config.getActiveState() + "] is unknown for state machine [AClient]");
		}
		}
	}
	
	private StateMachineConfig transiteToStableState(StateMachineContext context, StateMachinePath path, StateMachineConfig config) throws Exception {

		int s = decodeState(config.getActiveState());
		Event event;

		switch (s) {
									case Top:
					
										
					fireComeToState(context, path, "s1");

					// s1->1.   [true]/
					event = Event.NO_EVENT;
						fireTransitionFound(context, path, "s1", event, "s1#1.  ##true");
	
		
	fireComeToState(context, path, "1.  ");
	
	// 1.   [o1.z1]
				fireBeforeOutputActionExecution(context, path, "s1#1.  ##true", "o1.z1");

				o1.z1(context);
		
	fireAfterOutputActionExecution(context, path, "s1#1.  ##true", "o1.z1");
						
											return new StateMachineConfig("1.  ");
																																																																																							}
	
		return config;
	}    
	
	private StateMachineConfig lookForTransition(Event event, StateMachineContext context, StateMachinePath path, StateMachineConfig config) throws Exception {
					
		
				
		
	
				BitSet calculatedInputActions = new BitSet(0);
		
		int s = decodeState(config.getActiveState());
		int e = decodeEvent(event.getName());
	
		while (true) {
			switch (s) {
																										case _4___:
						
											
												switch (e) {
													case e4:
																
						// 4.  ->8.   e4[true]/
			
			fireTransitionCandidate(context, path, "4.  ", event, "4.  #8.  #e4#true");
			
						
							
			
							
					fireTransitionFound(context, path, "4.  ", event, "4.  #8.  #e4#true");
	
		
	fireComeToState(context, path, "8.  ");
	
	// 8.   [o1.z8]
				fireBeforeOutputActionExecution(context, path, "4.  #8.  #e4#true", "o1.z8");

				o1.z8(context);
		
	fireAfterOutputActionExecution(context, path, "4.  #8.  #e4#true", "o1.z8");
					return new StateMachineConfig("8.  ");

																				
														case e2:
																
						// 4.  ->13.   e2[true]/
			
			fireTransitionCandidate(context, path, "4.  ", event, "4.  #13.  #e2#true");
			
						
							
			
							
					fireTransitionFound(context, path, "4.  ", event, "4.  #13.  #e2#true");
	
		
	fireComeToState(context, path, "13.  ");
	
	// 13.   [o1.z13]
				fireBeforeOutputActionExecution(context, path, "4.  #13.  #e2#true", "o1.z13");

				o1.z13(context);
		
	fireAfterOutputActionExecution(context, path, "4.  #13.  #e2#true", "o1.z13");
					return new StateMachineConfig("13.  ");

																				
														case e3:
																
						// 4.  ->5.   e3[true]/
			
			fireTransitionCandidate(context, path, "4.  ", event, "4.  #5.  #e3#true");
			
						
							
			
							
					fireTransitionFound(context, path, "4.  ", event, "4.  #5.  #e3#true");
	
		
	fireComeToState(context, path, "5.  ");
	
	// 5.   [o2.z5]
				fireBeforeOutputActionExecution(context, path, "4.  #5.  #e3#true", "o2.z5");

				o2.z5(context);
		
	fireAfterOutputActionExecution(context, path, "4.  #5.  #e3#true", "o2.z5");
					return new StateMachineConfig("5.  ");

																				
													default:
														
							
										// transition not found
								return config;
												}
						
																						case _5___:
						
											
												switch (e) {
													case e15:
																
						// 5.  ->13.   e15[true]/
			
			fireTransitionCandidate(context, path, "5.  ", event, "5.  #13.  #e15#true");
			
						
							
			
							
					fireTransitionFound(context, path, "5.  ", event, "5.  #13.  #e15#true");
	
		
	fireComeToState(context, path, "13.  ");
	
	// 13.   [o1.z13]
				fireBeforeOutputActionExecution(context, path, "5.  #13.  #e15#true", "o1.z13");

				o1.z13(context);
		
	fireAfterOutputActionExecution(context, path, "5.  #13.  #e15#true", "o1.z13");
					return new StateMachineConfig("13.  ");

																				
														case e12:
																
						// 5.  ->6.    e12[true]/
			
			fireTransitionCandidate(context, path, "5.  ", event, "5.  #6.   #e12#true");
			
						
							
			
							
					fireTransitionFound(context, path, "5.  ", event, "5.  #6.   #e12#true");
	
		
	fireComeToState(context, path, "6.   ");
	
	// 6.    [o1.z6]
				fireBeforeOutputActionExecution(context, path, "5.  #6.   #e12#true", "o1.z6");

				o1.z6(context);
		
	fireAfterOutputActionExecution(context, path, "5.  #6.   #e12#true", "o1.z6");
					return new StateMachineConfig("6.   ");

																				
													default:
														
							
										// transition not found
								return config;
												}
						
																						case _3__:
						
											
												switch (e) {
													case e11:
																
						// 3. ->13.   e11[true]/
			
			fireTransitionCandidate(context, path, "3. ", event, "3. #13.  #e11#true");
			
						
							
			
							
					fireTransitionFound(context, path, "3. ", event, "3. #13.  #e11#true");
	
		
	fireComeToState(context, path, "13.  ");
	
	// 13.   [o1.z13]
				fireBeforeOutputActionExecution(context, path, "3. #13.  #e11#true", "o1.z13");

				o1.z13(context);
		
	fireAfterOutputActionExecution(context, path, "3. #13.  #e11#true", "o1.z13");
					return new StateMachineConfig("13.  ");

																				
														case e10:
																
						// 3. ->4.   e10[true]/
			
			fireTransitionCandidate(context, path, "3. ", event, "3. #4.  #e10#true");
			
						
							
			
							
					fireTransitionFound(context, path, "3. ", event, "3. #4.  #e10#true");
	
		
	fireComeToState(context, path, "4.  ");
	
	// 4.   [o1.z4]
				fireBeforeOutputActionExecution(context, path, "3. #4.  #e10#true", "o1.z4");

				o1.z4(context);
		
	fireAfterOutputActionExecution(context, path, "3. #4.  #e10#true", "o1.z4");
					return new StateMachineConfig("4.  ");

																				
													default:
														
							
										// transition not found
								return config;
												}
						
																						case _11___:
						
											
												switch (e) {
													case e2:
																
						// 11.  ->13.   e2[true]/
			
			fireTransitionCandidate(context, path, "11.  ", event, "11.  #13.  #e2#true");
			
						
							
			
							
					fireTransitionFound(context, path, "11.  ", event, "11.  #13.  #e2#true");
	
		
	fireComeToState(context, path, "13.  ");
	
	// 13.   [o1.z13]
				fireBeforeOutputActionExecution(context, path, "11.  #13.  #e2#true", "o1.z13");

				o1.z13(context);
		
	fireAfterOutputActionExecution(context, path, "11.  #13.  #e2#true", "o1.z13");
					return new StateMachineConfig("13.  ");

																				
														case e3:
																
						// 11.  ->12.   2 e3[true]/
			
			fireTransitionCandidate(context, path, "11.  ", event, "11.  #12.   2#e3#true");
			
						
							
			
							
					fireTransitionFound(context, path, "11.  ", event, "11.  #12.   2#e3#true");
	
		
	fireComeToState(context, path, "12.   2");
	
	// 12.   2 [o1.z12]
				fireBeforeOutputActionExecution(context, path, "11.  #12.   2#e3#true", "o1.z12");

				o1.z12(context);
		
	fireAfterOutputActionExecution(context, path, "11.  #12.   2#e3#true", "o1.z12");
					return new StateMachineConfig("12.   2");

																				
													default:
														
							
										// transition not found
								return config;
												}
						
																													case _13___:
						
											
												switch (e) {
													case e7:
																
						// 13.  ->1.   e7[true]/
			
			fireTransitionCandidate(context, path, "13.  ", event, "13.  #1.  #e7#true");
			
						
							
			
							
					fireTransitionFound(context, path, "13.  ", event, "13.  #1.  #e7#true");
	
		
	fireComeToState(context, path, "1.  ");
	
	// 1.   [o1.z1]
				fireBeforeOutputActionExecution(context, path, "13.  #1.  #e7#true", "o1.z1");

				o1.z1(context);
		
	fireAfterOutputActionExecution(context, path, "13.  #1.  #e7#true", "o1.z1");
					return new StateMachineConfig("1.  ");

																				
													default:
														
							
										// transition not found
								return config;
												}
						
																						case _12____2:
						
											
												switch (e) {
													case e8:
																
						// 12.   2->13.   e8[true]/
			
			fireTransitionCandidate(context, path, "12.   2", event, "12.   2#13.  #e8#true");
			
						
							
			
							
					fireTransitionFound(context, path, "12.   2", event, "12.   2#13.  #e8#true");
	
		
	fireComeToState(context, path, "13.  ");
	
	// 13.   [o1.z13]
				fireBeforeOutputActionExecution(context, path, "12.   2#13.  #e8#true", "o1.z13");

				o1.z13(context);
		
	fireAfterOutputActionExecution(context, path, "12.   2#13.  #e8#true", "o1.z13");
					return new StateMachineConfig("13.  ");

																				
													default:
														
							
										// transition not found
								return config;
												}
						
																						case _2___pin_:
						
											
												switch (e) {
													case e4:
																
						// 2.  pin ->3.  e4[true]/
			
			fireTransitionCandidate(context, path, "2.  pin ", event, "2.  pin #3. #e4#true");
			
						
							
			
							
					fireTransitionFound(context, path, "2.  pin ", event, "2.  pin #3. #e4#true");
	
		
	fireComeToState(context, path, "3. ");
	
	// 3.  [o2.z3]
				fireBeforeOutputActionExecution(context, path, "2.  pin #3. #e4#true", "o2.z3");

				o2.z3(context);
		
	fireAfterOutputActionExecution(context, path, "2.  pin #3. #e4#true", "o2.z3");
					return new StateMachineConfig("3. ");

																				
														case e2:
																
						// 2.  pin ->13.   e2[true]/
			
			fireTransitionCandidate(context, path, "2.  pin ", event, "2.  pin #13.  #e2#true");
			
						
							
			
							
					fireTransitionFound(context, path, "2.  pin ", event, "2.  pin #13.  #e2#true");
	
		
	fireComeToState(context, path, "13.  ");
	
	// 13.   [o1.z13]
				fireBeforeOutputActionExecution(context, path, "2.  pin #13.  #e2#true", "o1.z13");

				o1.z13(context);
		
	fireAfterOutputActionExecution(context, path, "2.  pin #13.  #e2#true", "o1.z13");
					return new StateMachineConfig("13.  ");

																				
													default:
														
							
										// transition not found
								return config;
												}
						
																						case _8___:
						
											
												switch (e) {
													case e4:
																
						// 8.  ->9.   e4[true]/
			
			fireTransitionCandidate(context, path, "8.  ", event, "8.  #9.  #e4#true");
			
						
							
			
							
					fireTransitionFound(context, path, "8.  ", event, "8.  #9.  #e4#true");
	
		
	fireComeToState(context, path, "9.  ");
	
	// 9.   [o2.z9]
				fireBeforeOutputActionExecution(context, path, "8.  #9.  #e4#true", "o2.z9");

				o2.z9(context);
		
	fireAfterOutputActionExecution(context, path, "8.  #9.  #e4#true", "o2.z9");
					return new StateMachineConfig("9.  ");

																				
														case e2:
																
						// 8.  ->13.   e2[true]/
			
			fireTransitionCandidate(context, path, "8.  ", event, "8.  #13.  #e2#true");
			
						
							
			
							
					fireTransitionFound(context, path, "8.  ", event, "8.  #13.  #e2#true");
	
		
	fireComeToState(context, path, "13.  ");
	
	// 13.   [o1.z13]
				fireBeforeOutputActionExecution(context, path, "8.  #13.  #e2#true", "o1.z13");

				o1.z13(context);
		
	fireAfterOutputActionExecution(context, path, "8.  #13.  #e2#true", "o1.z13");
					return new StateMachineConfig("13.  ");

																				
													default:
														
							
										// transition not found
								return config;
												}
						
																						case _10___:
						
											
												switch (e) {
													case e9:
																
						// 10.  ->11.   e9[true]/
			
			fireTransitionCandidate(context, path, "10.  ", event, "10.  #11.  #e9#true");
			
						
							
			
							
					fireTransitionFound(context, path, "10.  ", event, "10.  #11.  #e9#true");
	
		
	fireComeToState(context, path, "11.  ");
	
	// 11.   [o1.z11]
				fireBeforeOutputActionExecution(context, path, "10.  #11.  #e9#true", "o1.z11");

				o1.z11(context);
		
	fireAfterOutputActionExecution(context, path, "10.  #11.  #e9#true", "o1.z11");
					return new StateMachineConfig("11.  ");

																				
													default:
														
							
										// transition not found
								return config;
												}
						
																						case _9___:
						
											
												switch (e) {
													case e13:
																
						// 9.  ->10.   e13[true]/
			
			fireTransitionCandidate(context, path, "9.  ", event, "9.  #10.  #e13#true");
			
						
							
			
							
					fireTransitionFound(context, path, "9.  ", event, "9.  #10.  #e13#true");
	
		
	fireComeToState(context, path, "10.  ");
	
	// 10.   [o1.z10]
				fireBeforeOutputActionExecution(context, path, "9.  #10.  #e13#true", "o1.z10");

				o1.z10(context);
		
	fireAfterOutputActionExecution(context, path, "9.  #10.  #e13#true", "o1.z10");
					return new StateMachineConfig("10.  ");

																				
														case e14:
																
						// 9.  ->13.   e14[true]/
			
			fireTransitionCandidate(context, path, "9.  ", event, "9.  #13.  #e14#true");
			
						
							
			
							
					fireTransitionFound(context, path, "9.  ", event, "9.  #13.  #e14#true");
	
		
	fireComeToState(context, path, "13.  ");
	
	// 13.   [o1.z13]
				fireBeforeOutputActionExecution(context, path, "9.  #13.  #e14#true", "o1.z13");

				o1.z13(context);
		
	fireAfterOutputActionExecution(context, path, "9.  #13.  #e14#true", "o1.z13");
					return new StateMachineConfig("13.  ");

																				
													default:
														
							
										// transition not found
								return config;
												}
						
																						case _1___:
						
											
												switch (e) {
													case e0:
																
						// 1.  ->s2 e0[true]/o1.z0
			
			fireTransitionCandidate(context, path, "1.  ", event, "1.  #s2#e0#true");
			
						
							
			
							
					fireTransitionFound(context, path, "1.  ", event, "1.  #s2#e0#true");
	
				fireBeforeOutputActionExecution(context, path, "1.  #s2#e0#true", "o1.z0");

				o1.z0(context);
		
	fireAfterOutputActionExecution(context, path, "1.  #s2#e0#true", "o1.z0");
		
	fireComeToState(context, path, "s2");
	
	// s2 []
					return new StateMachineConfig("s2");

																				
														case e6:
																
						// 1.  ->2.  pin  e6[true]/
			
			fireTransitionCandidate(context, path, "1.  ", event, "1.  #2.  pin #e6#true");
			
						
							
			
							
					fireTransitionFound(context, path, "1.  ", event, "1.  #2.  pin #e6#true");
	
		
	fireComeToState(context, path, "2.  pin ");
	
	// 2.  pin  [o1.z2]
				fireBeforeOutputActionExecution(context, path, "1.  #2.  pin #e6#true", "o1.z2");

				o1.z2(context);
		
	fireAfterOutputActionExecution(context, path, "1.  #2.  pin #e6#true", "o1.z2");
					return new StateMachineConfig("2.  pin ");

																				
													default:
														
							
										// transition not found
								return config;
												}
						
																						case _7____1:
						
											
												switch (e) {
													case e8:
																
						// 7.   1->13.   e8[true]/
			
			fireTransitionCandidate(context, path, "7.   1", event, "7.   1#13.  #e8#true");
			
						
							
			
							
					fireTransitionFound(context, path, "7.   1", event, "7.   1#13.  #e8#true");
	
		
	fireComeToState(context, path, "13.  ");
	
	// 13.   [o1.z13]
				fireBeforeOutputActionExecution(context, path, "7.   1#13.  #e8#true", "o1.z13");

				o1.z13(context);
		
	fireAfterOutputActionExecution(context, path, "7.   1#13.  #e8#true", "o1.z13");
					return new StateMachineConfig("13.  ");

																				
													default:
														
							
										// transition not found
								return config;
												}
						
																						case _6____:
						
											
												switch (e) {
													case e4:
																
						// 6.   ->13.   e4[true]/
			
			fireTransitionCandidate(context, path, "6.   ", event, "6.   #13.  #e4#true");
			
						
							
			
							
					fireTransitionFound(context, path, "6.   ", event, "6.   #13.  #e4#true");
	
		
	fireComeToState(context, path, "13.  ");
	
	// 13.   [o1.z13]
				fireBeforeOutputActionExecution(context, path, "6.   #13.  #e4#true", "o1.z13");

				o1.z13(context);
		
	fireAfterOutputActionExecution(context, path, "6.   #13.  #e4#true", "o1.z13");
					return new StateMachineConfig("13.  ");

																				
														case e3:
																
						// 6.   ->7.   1 e3[true]/
			
			fireTransitionCandidate(context, path, "6.   ", event, "6.   #7.   1#e3#true");
			
						
							
			
							
					fireTransitionFound(context, path, "6.   ", event, "6.   #7.   1#e3#true");
	
		
	fireComeToState(context, path, "7.   1");
	
	// 7.   1 [o1.z7]
				fireBeforeOutputActionExecution(context, path, "6.   #7.   1#e3#true", "o1.z7");

				o1.z7(context);
		
	fireAfterOutputActionExecution(context, path, "6.   #7.   1#e3#true", "o1.z7");
					return new StateMachineConfig("7.   1");

																				
													default:
														
							
										// transition not found
								return config;
												}
						
																	default:
					throw new EventProcessorException("Incorrect stable state [" + config.getActiveState() + "] in state machine [AClient]");
			}
		}
	}

		        
}
			







private class AServerEventProcessor {

		// states
	    private static final int Top = 1;
	    private static final int s1 = 2;
	    private static final int _ = 3;
	    private static final int s2 = 4;
	    private static final int _ = 5;
	    private static final int  = 6;
	    private static final int  = 7;
	    private static final int _ = 8;
	
	private int decodeState(String state) {
					
		if ("Top".equals(state)) {
			return Top;
						} else 
				
		if ("s1".equals(state)) {
			return s1;
						} else 
				
		if (" ".equals(state)) {
			return _;
						} else 
				
		if ("s2".equals(state)) {
			return s2;
						} else 
				
		if (" ".equals(state)) {
			return _;
						} else 
				
		if ("".equals(state)) {
			return ;
						} else 
				
		if ("".equals(state)) {
			return ;
						} else 
				
		if (" ".equals(state)) {
			return _;
			}
		
		return -1;
	}
	
		// events
	    private static final int e24 = 1;
	    private static final int e22 = 2;
	    private static final int e21 = 3;
	    private static final int e23 = 4;
	
	private int decodeEvent(String event) {
					
		if ("e24".equals(event)) {
			return e24;
						} else 
				
		if ("e22".equals(event)) {
			return e22;
						} else 
				
		if ("e21".equals(event)) {
			return e21;
						} else 
				
		if ("e23".equals(event)) {
			return e23;
				}
	
		return -1;
	}
		
							private callserver.ServerReply o3;
				
	private void init(ControlledObjectsMap controlledObjectsMap) {
									o3 = (callserver.ServerReply)controlledObjectsMap.getControlledObject("o3");
						}
		
	private StateMachineConfig process(Event event, StateMachineContext context, StateMachinePath path, StateMachineConfig config) throws Exception {
		config = lookForTransition(event, context, path, config);
		
		config = transiteToStableState(context, path, config);
		
		// execute included state machines
		executeSubmachines(event, context, path, config);
		
		return config;
	}
	
	private void executeSubmachines(Event event, StateMachineContext context, StateMachinePath path, StateMachineConfig config) throws Exception {
		int state = decodeState(config.getActiveState());
		
		while (true) {
		switch (state) {
																			case s1: 
					
											return;
																					case _: 
					
											return;
																					case s2: 
					
											return;
																					case _: 
					
											return;
																					case : 
					
											return;
																					case : 
					
											return;
																					case _: 
					
											return;
																default:
					throw new EventProcessorException("State with name [" + config.getActiveState() + "] is unknown for state machine [AServer]");
		}
		}
	}
	
	private StateMachineConfig transiteToStableState(StateMachineContext context, StateMachinePath path, StateMachineConfig config) throws Exception {

		int s = decodeState(config.getActiveState());
		Event event;

		switch (s) {
									case Top:
					
										
					fireComeToState(context, path, "s1");

					// s1->  [true]/
					event = Event.NO_EVENT;
						fireTransitionFound(context, path, "s1", event, "s1# ##true");
	
		
	fireComeToState(context, path, " ");
	
	//   [o3.z0]
				fireBeforeOutputActionExecution(context, path, "s1# ##true", "o3.z0");

				o3.z0(context);
		
	fireAfterOutputActionExecution(context, path, "s1# ##true", "o3.z0");
						
											return new StateMachineConfig(" ");
																																															}
	
		return config;
	}    
	
	private StateMachineConfig lookForTransition(Event event, StateMachineContext context, StateMachinePath path, StateMachineConfig config) throws Exception {
					
		
				
		
	
				BitSet calculatedInputActions = new BitSet(0);
		
		int s = decodeState(config.getActiveState());
		int e = decodeEvent(event.getName());
	
		while (true) {
			switch (s) {
																										case _:
						
											
												switch (e) {
												default:
														
						//  ->s2 *[true]/
			
			fireTransitionCandidate(context, path, " ", event, " #s2#*#true");
			
						
							
			
							
					fireTransitionFound(context, path, " ", event, " #s2#*#true");
	
		
	fireComeToState(context, path, "s2");
	
	// s2 []
					return new StateMachineConfig("s2");

																				
							}
						
																													case _:
						
											
												switch (e) {
													case e24:
																
						//  ->  e24[true]/
			
			fireTransitionCandidate(context, path, " ", event, " # #e24#true");
			
						
							
			
							
					fireTransitionFound(context, path, " ", event, " # #e24#true");
	
		
	fireComeToState(context, path, " ");
	
	//   [o3.z4]
				fireBeforeOutputActionExecution(context, path, " # #e24#true", "o3.z4");

				o3.z4(context);
		
	fireAfterOutputActionExecution(context, path, " # #e24#true", "o3.z4");
					return new StateMachineConfig(" ");

																				
													default:
														
							
										// transition not found
								return config;
												}
						
																						case :
						
											
												switch (e) {
													case e24:
																
						// ->  e24[true]/
			
			fireTransitionCandidate(context, path, "", event, "# #e24#true");
			
						
							
			
							
					fireTransitionFound(context, path, "", event, "# #e24#true");
	
		
	fireComeToState(context, path, " ");
	
	//   [o3.z4]
				fireBeforeOutputActionExecution(context, path, "# #e24#true", "o3.z4");

				o3.z4(context);
		
	fireAfterOutputActionExecution(context, path, "# #e24#true", "o3.z4");
					return new StateMachineConfig(" ");

																				
													default:
														
							
										// transition not found
								return config;
												}
						
																						case :
						
											
												switch (e) {
													case e24:
																
						// ->  e24[true]/
			
			fireTransitionCandidate(context, path, "", event, "# #e24#true");
			
						
							
			
							
					fireTransitionFound(context, path, "", event, "# #e24#true");
	
		
	fireComeToState(context, path, " ");
	
	//   [o3.z4]
				fireBeforeOutputActionExecution(context, path, "# #e24#true", "o3.z4");

				o3.z4(context);
		
	fireAfterOutputActionExecution(context, path, "# #e24#true", "o3.z4");
					return new StateMachineConfig(" ");

																				
													default:
														
							
										// transition not found
								return config;
												}
						
																						case _:
						
											
												switch (e) {
													case e22:
																
						//  -> e22[true]/
			
			fireTransitionCandidate(context, path, " ", event, " ##e22#true");
			
						
							
			
							
					fireTransitionFound(context, path, " ", event, " ##e22#true");
	
		
	fireComeToState(context, path, "");
	
	//  [o3.z2]
				fireBeforeOutputActionExecution(context, path, " ##e22#true", "o3.z2");

				o3.z2(context);
		
	fireAfterOutputActionExecution(context, path, " ##e22#true", "o3.z2");
					return new StateMachineConfig("");

																				
														case e21:
																
						//  -> e21[true]/
			
			fireTransitionCandidate(context, path, " ", event, " ##e21#true");
			
						
							
			
							
					fireTransitionFound(context, path, " ", event, " ##e21#true");
	
		
	fireComeToState(context, path, "");
	
	//  [o3.z1]
				fireBeforeOutputActionExecution(context, path, " ##e21#true", "o3.z1");

				o3.z1(context);
		
	fireAfterOutputActionExecution(context, path, " ##e21#true", "o3.z1");
					return new StateMachineConfig("");

																				
														case e23:
																
						//  ->  e23[true]/
			
			fireTransitionCandidate(context, path, " ", event, " # #e23#true");
			
						
							
			
							
					fireTransitionFound(context, path, " ", event, " # #e23#true");
	
		
	fireComeToState(context, path, " ");
	
	//   [o3.z3]
				fireBeforeOutputActionExecution(context, path, " # #e23#true", "o3.z3");

				o3.z3(context);
		
	fireAfterOutputActionExecution(context, path, " # #e23#true", "o3.z3");
					return new StateMachineConfig(" ");

																				
													default:
														
							
										// transition not found
								return config;
												}
						
																	default:
					throw new EventProcessorException("Incorrect stable state [" + config.getActiveState() + "] in state machine [AServer]");
			}
		}
	}

		        
}
	
	private static boolean isInputActionCalculated(BitSet calculatedInputActions, int k) {
		boolean b = calculatedInputActions.get(k);
            
        if (!b) {
			calculatedInputActions.set(k);
		}
            
        return b;
	}
	
}
	
