package callserver;

import java.rmi.*;
import java.net.*;


import client.ServerEventProvider;
import client.ServerQuery;
import server.Bank;

import com.evelopers.unimod.runtime.ControlledObject;
import com.evelopers.unimod.runtime.context.StateMachineContext;

public class ServerReply implements ControlledObject {
	private char command;
	private int cardN;
	private int cardPIN;
	private int money;
	private String reply;
	Bank bank; 
	
	
	/**
	 * @unimod.action.descr  
	 */
	public void z0(StateMachineContext context) {
		command = ServerQuery.ServerInfo.command;
		cardN = ServerQuery.ServerInfo.cardN;
		cardPIN = ServerQuery.ServerInfo.cardPIN;
		money = ServerQuery.ServerInfo.money;
		switch(command){
		case 'A': ClientEventProvider.notify(ClientEventProvider.E21); break;
		case 'B': ClientEventProvider.notify(ClientEventProvider.E22); break;
		case 'G': ClientEventProvider.notify(ClientEventProvider.E23); break;
		}
	}
	
	/**
	 * @unimod.action.descr 
	 */
	public void z1(StateMachineContext context) {
		try{
			bank = (Bank)Naming.lookup("rmi://localhost/bank");
		}catch(NotBoundException e){
			System.out.println("Not bound");
			e.printStackTrace();
		}catch(MalformedURLException e){
			System.out.println("MalformedURL");		
			e.printStackTrace();
		}catch(RemoteException e){
			System.out.println("RemoteException");			
			e.printStackTrace();
		};
		   
		try{
			if(bank.checkCard(cardN, cardPIN))
				reply = ServerEventProvider.E10;
			else
				reply = ServerEventProvider.E11;
		}catch(RemoteException e){
			reply = ServerEventProvider.E15;
		}
		ClientEventProvider.notify(ClientEventProvider.E24);
	}

	/**
	 * @unimod.action.descr  
	 */
	public void z2(StateMachineContext context) {
		try{
			ServerQuery.ServerInfo.balance = bank.getBalance(cardN, cardPIN);
			reply = ServerEventProvider.E12;
		}catch(RemoteException e){
			reply = ServerEventProvider.E15;
		}
		ClientEventProvider.notify(ClientEventProvider.E24);
	}

	/**
	 * @unimod.action.descr  
	 */
	public void z3(StateMachineContext context) {
		try{
			if(bank.getMoney(cardN, cardPIN, money))
				reply = ServerEventProvider.E13;
			else
				reply = ServerEventProvider.E14;
		}catch(RemoteException e){
			reply = ServerEventProvider.E15;
		}
		ClientEventProvider.notify(ClientEventProvider.E24);
	}

	/**
	 * @unimod.action.descr  
	 */
	public void z4(StateMachineContext context) {
		ClientEventProvider.notify("");
		ClientEventProvider.notify(reply);
	}

}
