package client;

import java.awt.event.*;
import java.awt.*;
import java.text.*;
import java.util.*;
import javax.swing.*;

import com.evelopers.unimod.core.stateworks.Event;
import com.evelopers.unimod.runtime.ModelEngine;
import com.evelopers.unimod.runtime.context.StateMachineContextImpl;


public class TForm extends JFrame implements ActionListener{
	static final long serialVersionUID = 2345723894503742L; 
    private ModelEngine engine = null;
    public Locale locale = new Locale("ru", "RU");
    ResourceBundle rb = ResourceBundle.getBundle("MessagesBundle", locale);
    public PanelMain panelMain; 
    
	TForm(ModelEngine engine){
		
		super("Bankomat");
		this.setResizable(false);
		this.setUndecorated(true);
		this.engine = engine;
		
		panelMain = new PanelMain(this);
		panelMain.showState("init", null, null, null, "");
		setContentPane(panelMain);
		setBounds(100, 100, 640, 480);
		setLocation(100, 100);
		setVisible(true);
	}
	
	public void notify(String event){
		engine.getEventManager().handle(new Event(event), StateMachineContextImpl.create());
	}
	
	public void actionPerformed(ActionEvent e){
		if(e.getSource() == panelMain.button_Off)
			notify(HumanEventProvider.E0);
		if(e.getSource() == panelMain.button1)
			notify(HumanEventProvider.E1);
		if(e.getSource() == panelMain.button2)
			notify(HumanEventProvider.E2);
		if(e.getSource() == panelMain.button3)
			notify(HumanEventProvider.E3);
		if(e.getSource() == panelMain.button4)
			notify(HumanEventProvider.E4);

		if(e.getSource() == panelMain.button_Ins)
			notify(HardwareEventProvider.E6);
		if(e.getSource() == panelMain.button_BackCard){
			panelMain.showState("", "state13", "serverstateoff", "st13label", "");
			HardwareEventProvider.setTimeout(HardwareEventProvider.E7, 2000);
		}
		if(e.getSource() == panelMain.button_CheckOut1)
			notify(HardwareEventProvider.E8);
		if(e.getSource() == panelMain.button_CheckOut2)
			notify(HardwareEventProvider.E8);
		if(e.getSource() == panelMain.button_MoneyOut)
			notify(HardwareEventProvider.E9);
		if(e.getSource() == panelMain.btnRussian){
			panelMain.btnEnglish.setSelected(false);
			panelMain.setRB(new Locale("ru", "RU"));
			panelMain.showState(panelMain.curstate.state, panelMain.curstate.stateN, panelMain.curstate.serverState, panelMain.curstate.mess, panelMain.curstate.adv);
			panelMain.markButton(panelMain.curbtn.sb1, panelMain.curbtn.sb2, panelMain.curbtn.sb3, panelMain.curbtn.sb4);
			panelMain.button_Off.setText(panelMain.f.rb.getString("exit"));
			panelMain.label_Welcome.setText(panelMain.f.rb.getString("welcomelabel"));
		}
		if(e.getSource() == panelMain.btnEnglish){
			panelMain.btnRussian.setSelected(false);
			panelMain.setRB(new Locale("en", "US"));
			
			panelMain.showState(panelMain.curstate.state, panelMain.curstate.stateN, panelMain.curstate.serverState, panelMain.curstate.mess, panelMain.curstate.adv);
			panelMain.markButton(panelMain.curbtn.sb1, panelMain.curbtn.sb2, panelMain.curbtn.sb3, panelMain.curbtn.sb4);
			panelMain.button_Off.setText(panelMain.f.rb.getString("exit"));
			panelMain.label_Welcome.setText(panelMain.f.rb.getString("welcomelabel"));
		
		}
	}
}


/////////////////////////////////////////////////////////////////////////////////////////////////////////
class CurrentState{
	public String state;
	public String stateN;
	public String serverState;
	public String mess;
	public String adv;
	public CurrentState(String state, String stateN, String serverState, String mess, String adv){
		this.state = state;
		this.stateN = stateN;
		this.serverState = serverState;
		this.mess = mess;
		this.adv = adv;
	}
}
class CurrentButton{
	public String sb1;
	public String sb2;
	public String sb3;
	public String sb4;
	public CurrentButton( String st1, String st2, String st3, String st4){
		this.sb1 = st1;
		this.sb2 = st2;
		this.sb3 = st3;
		this.sb4 = st4;
	}
}////////////////////////////////////////

class PanelMain extends Panel{
	private static final long serialVersionUID = 8879386965910815653L;
	
	CurrentButton curbtn = new CurrentButton("", "", "", "");
	CurrentState curstate = new CurrentState("", "", "", "", "");
	public TForm f;

    protected Font messageFont = new Font("Arial", Font.BOLD, 20);
    
	private ImageIcon img = new ImageIcon(TForm.class.getResource("Img/00.gif"));
	private JLabel img_Label = new JLabel(img);
	
	public JButton button1 = new JButton("");;
	public JButton button2 = new JButton("");;
	public JButton button3 = new JButton("");;
	public JButton button4 = new JButton("");;
	
	public JLabel buttonLabel1 = new JLabel("");
	public JLabel buttonLabel2 = new JLabel("");
	public JLabel buttonLabel3 = new JLabel("", JLabel.RIGHT);
	public JLabel buttonLabel4 = new JLabel("", JLabel.RIGHT);

	public JLabel label_State = new JLabel("");
	public JLabel label_ServerState = new JLabel("");
	public JLabel label_Mess = new JLabel("");

	public JTextField edit_N = new JTextField("");
	public JButton button_Ins = new JButton("^");
	public JButton button_Off;
	public ImageIcon imgCard = new ImageIcon(TForm.class.getResource("Img/01.gif"));
	public JLabel label_ImgCard = new JLabel(imgCard);
	public JLabel label_Welcome;
	
    public JTextField edit_Pin = new JTextField("");
	
	public JButton button_BackCard = new JButton("v");
	public ImageIcon imgBackCard = new ImageIcon(TForm.class.getResource("Img/02.gif"));
	public JLabel label_ImgBackCard = new JLabel(imgBackCard);
	
	public JTextField edit_Summ = new JTextField("");

	public JButton button_MoneyOut = new JButton("v");
	public ImageIcon imgMoneyOut = new ImageIcon(TForm.class.getResource("Img/03.gif"));
	public JLabel label_ImgMoneyOut = new JLabel(imgMoneyOut);
	
	public JButton button_CheckOut1 = new JButton("v");
	public JButton button_CheckOut2 = new JButton("v");
	public ImageIcon imgCheckOut = new ImageIcon(TForm.class.getResource("Img/04.gif"));
	public JLabel label_ImgCheckOut = new JLabel(imgCheckOut);
	
	JRadioButton btnRussian = new JRadioButton("");
	JRadioButton btnEnglish = new JRadioButton("English");
	
	
	public void setRB(Locale l){
		f.rb = ResourceBundle.getBundle("MessagesBundle", l);
	}
	void ladd(JLabel l){
		add(l);
		l.setFont(messageFont);
		l.setHorizontalAlignment(0);
		l.setForeground(Color.yellow);
	}
	
	void l2add(JLabel l){
		add(l);
		buttonLabel1.setVisible(true);
		l.setForeground(Color.green);
	}
	
	void badd(JButton b){
		add(b);
		b.setVisible(true);
		b.addActionListener(f);
		setComponentZOrder(b, 1);
	}

	PanelMain(TForm f){
		
		this.f = f;
		button_Off = new JButton(f.rb.getString("exit"));
		label_Welcome = new JLabel(f.rb.getString("welcomelabel"));
		
		
		l2add(label_State);
		l2add(label_ServerState);
		ladd(label_Mess);

		badd(button_Off);
		badd(button_Ins);
		add(edit_N);
		add(label_ImgCard);
		ladd(label_Welcome);
		
		add(edit_Pin);
		
		badd(button_BackCard);
		add(label_ImgBackCard);
		
		add(edit_Summ);
		
		badd(button_MoneyOut);
		add(label_ImgMoneyOut);
		
		badd(button_CheckOut1);
		badd(button_CheckOut2);
		add(label_ImgCheckOut);
		
	//main
		badd(button1);
		badd(button2);
		badd(button3);
		badd(button4);
		
		l2add(buttonLabel1);
		l2add(buttonLabel2);
		l2add(buttonLabel3);
		l2add(buttonLabel4);
		
//		
		add(btnRussian);
		btnRussian.setVisible(true);
		btnRussian.addActionListener(f);
		setComponentZOrder(btnRussian, 1);
		btnRussian.setBackground(new Color(100, 100, 100));
		btnRussian.setForeground(Color.YELLOW);
		btnRussian.setSelected(true);
		
		add(btnEnglish);
		btnEnglish.setVisible(true);
		btnEnglish.addActionListener(f);
		setComponentZOrder(btnEnglish, 1);
		btnEnglish.setBackground(new Color(100, 100, 100));
		btnEnglish.setForeground(Color.YELLOW);
		
		add(img_Label);
    	img_Label.setVisible(true);
    	
    	
	}
	
	public void markButton(String sb1, String sb2, String sb3, String sb4){
		buttonLabel1.setText(f.rb.getString(sb1)); 
		buttonLabel2.setText(f.rb.getString(sb2)); 
		buttonLabel3.setText(f.rb.getString(sb3)); 
		buttonLabel4.setText(f.rb.getString(sb4)); 
		curbtn.sb1 = sb1;
		curbtn.sb2 = sb2;
		curbtn.sb3 = sb3;
		curbtn.sb4 = sb4;
	}
	
	public void showState(String state, String stateN, String serverState, String mess, String adv){
		if(stateN == null){
			curstate.state = "";
			curstate.stateN = "";
			
			label_State.setVisible(false);
		}else{
			curstate.state = state;
			curstate.stateN = stateN;
			
			label_State.setText("<html>"+ f.rb.getString("titleclientstate")+ " " + f.rb.getString(stateN) + "</html>");
			label_State.setVisible(true);
			label_ServerState.setText("<html>"+ f.rb.getString("titleserverstate")+ " " + f.rb.getString(serverState) + "</html>");
			label_ServerState.setVisible(true);

		}
		curstate.serverState = serverState;
		curstate.mess = mess;
		curstate.adv = adv;
	
		
		if(mess != null) label_Mess.setText(f.rb.getString(mess) + adv);
		label_Mess.setVisible(mess != "");
		

		button_Off.setVisible(state == "welcome");
		button_Ins.setVisible(state == "welcome");
		edit_N.setVisible(state == "welcome");
		label_ImgCard.setVisible(state == "welcome");
		label_Welcome.setVisible(state == "welcome");
		
		edit_Pin.setVisible(state == "enter pin");
		
		button_BackCard.setVisible(state == "back card");
		label_ImgBackCard.setVisible(state == "back card");
		
		edit_Summ.setVisible(state == "enter summ");
		
		button_MoneyOut.setVisible(state == "money out");
		label_ImgMoneyOut.setVisible(state == "money out");
		
		button_CheckOut1.setVisible(state == "print1");
		button_CheckOut2.setVisible(state == "print2");
		label_ImgCheckOut.setVisible((state == "print1")||(state == "print2"));
		
		btnRussian.setVisible(true);
		btnEnglish.setVisible(true);
		
		
	}
	
	public void doLayout(){
		img_Label.setBounds(0, 0, 640, 480);

		button1.setBounds(20, 335, 90, 30);
		button2.setBounds(20, 380, 90, 30);
		button3.setBounds(520, 335, 90, 30);
		button4.setBounds(520, 380, 90, 30);
		
		buttonLabel1.setBounds(150, 335, 160, 30);
		buttonLabel2.setBounds(150, 380, 160, 30);
		buttonLabel3.setBounds(320, 335, 160, 30);
		buttonLabel4.setBounds(320, 380, 160, 30);
		
		label_Mess.setBounds(150, 200, 330, 150);
		label_State.setBounds(150, 15, 330, 40);
		label_ServerState.setBounds(150, 45, 330, 30);

		button_Off.setBounds(555, 455, 80, 20);
		button_Ins.setBounds(550, 80, 50, 15);
		edit_N.setBounds(510, 80, 40, 15);
		label_ImgCard.setBounds(0, 0, 640, 480);
		label_Welcome.setBounds(150, 150, 330, 50);
		
		edit_Pin.setBounds(320, 330, 50, 20);
		
		button_BackCard.setBounds(540, 100, 50, 15);
		label_ImgBackCard.setBounds(0, 0, 640, 480);

		edit_Summ.setBounds(280, 330, 80, 20);

		button_MoneyOut.setBounds(550, 160, 50, 15);
		label_ImgMoneyOut.setBounds(0, 0, 640, 480);

		button_CheckOut1.setBounds(550, 110, 50, 15);
		button_CheckOut2.setBounds(550, 110, 50, 15);
		label_ImgCheckOut.setBounds(0, 0, 640, 480);
		
		btnRussian.setBounds(10, 10, 100, 20);
		btnEnglish.setBounds(10, 30, 100, 20);
	}
}
